;**********************************
;
; Routines to save and restore the processor working files 
; when an interrupt is generated
;
;********************************
;
SAVE_PROCESSOR:
	sts	registers+16,temp	; first save temp register
	sts	registers+17,temp_1	; and temp_1
	in	temp,SREG		; get current status of processor
	sts	status_reg,temp		; and save
	sts	registers+28,r28	; save Z and Y
	sts	registers+29,r29
	sts	registers+30,r30	; save Z and Y
	sts	registers+31,r31
	ldi	temp,16			; loop counter
	clr	r30			; Z points to working register
	clr	r31			; 
	clr	r29			; Y points to SRAM location
	ldi	r28,registers		; 
LOOP_SP1:
	ld	temp_1,Z
	st	Y,temp_1		; Save location 
	inc	r30
	inc	r28			; next location
	dec	temp
	brne	LOOP_SP1		; next location
;
	ldi	temp,10			; loop counter
	inc	r30			; skip r16
	inc	r28			; 
	inc	r30
	inc	r28			; and r17
LOOP_SP2:
	ld	temp_1,Z
	st	Y,temp_1		; Save location 
	inc	r30
	inc	r28			;
	dec	temp
	brne	LOOP_SP2		; next location
	ret

RESTORE_PROCESSOR:
	ldi	temp,16			; loop counter
	clr	r30			; Z points to working register
	clr	r31			; 
	clr	r29			; Y points to SRAM location
	ldi	r28,registers		; 
LOOP_RP1:
	ld	temp_1,Y		; get SRAM data
	st	Z,temp_1		; Save location 
	inc	r30
	inc	r28			; next location
	dec	temp
	brne	LOOP_RP1			; next location
;
	ldi	temp,10			; loop counter
	inc	r30			; skip r16
	inc	r28			; 
	inc	r30
	inc	r28			; and r17
LOOP_RP2:
	ld	temp_1,Y
	st	Z,temp_1		; restore location 
	inc	r30
	inc	r28			;
	dec	temp
	brne	LOOP_RP2		; next location
;
	lds	temp_1,registers+17	; restore temp_1
	lds	r28,registers+28	; Restore pointers
	lds	r29,registers+29
	lds	r30,registers+30
	lds	r31,registers+31
	lds	temp,status_reg		; and status reg
	out	SREG,temp		; 
	lds	temp,registers+16	; restore temp register
	ret