;**************************
;
; Sweep module
;
; Accepts keypad input for 	Start freq
;				Stop freq
;				Freq step 
;				Step time
;				Marker
;************************
SWEEP:
        ldi     temp,$01                ; Clear display
        rcall   COMMAND_DISPLAY
        rcall   WAIT_2msec
	ldi	temp,$0F		; Cursor on, flashing on
	rcall	COMMAND_DISPLAY
	rcall	WAIT_2msec
	ldi     temp,$C0        	; Cursor to 40
	rcall    COMMAND_DISPLAY	; Write to second line
        ldi     temp,$20                ; Blank
        rcall   DATA_DISPLAY
        ldi     temp,$53                ; S
        rcall   DATA_DISPLAY
        ldi     temp,$57                ; W
        rcall   DATA_DISPLAY
        ldi     temp,$45                ; E
        rcall   DATA_DISPLAY
        ldi     temp,$45                ; E
        rcall   DATA_DISPLAY
        ldi     temp,$50                ; P
        rcall   DATA_DISPLAY
        ldi     temp,$20                ; Blank
        rcall   DATA_DISPLAY
        ldi     temp,$53                ; S
        rcall   DATA_DISPLAY
        ldi     temp,$54                ; T
        rcall   DATA_DISPLAY
        ldi     temp,$41                ; A
        rcall   DATA_DISPLAY
        ldi     temp,$52                ; R
        rcall   DATA_DISPLAY
        ldi     temp,$54                ; T
        rcall   DATA_DISPLAY
;*******************************
; Write the current entered data
; and get the required BCD data
;********************************
	clr	temp	
	sts	AtKEYFLAGS,temp		; Clear keypress flag		
;
S1REFJUMP1:
	rcall	DISPLAY_FREQ		; Display current digits
;
	ldi	temp,$81		; Set cursor
	lds	temp_1,AtKEYFLAGS		
	andi	temp_1,$07		; Mask off all bit but digit count
	cpi	temp_1,2		; If more than 2 digits then skip *
	brlo	S1SKIP_STAR
	inc	temp_1
S1SKIP_STAR:
	add	temp,temp_1		; Adjust to current digit
	rcall	COMMAND_DISPLAY
;
		
S1WAIT_FOR_KEY:
	lds 	temp,AtKEYFLAGS		; wait for keypreess
        sbrs    temp,4          	; 
        rjmp    S1WAIT_FOR_KEY        	; 
;
	lds	temp,AtKEYPRESS		; Get current keypress
	cpi	temp,$23		; ? is keypress #
	breq	S1REFEND		; if so then end	
;
;******************************
; Calculate address of BCD data
;*****************************					
	ldi	temp_1,AtBCD		; address of BCD data
	lds	temp,AtKEYFLAGS		; Get current digit
	andi	temp,$07		; Mask off all but current digit
	mov	temp_2,temp		; make copy 
	asr	temp_2			; divide by 2
	add	temp_1,temp_2		; add to pointer to AtBCD
	mov	r30,temp_1		; Use Z as pointer
	clr	r31
;
	lds	temp,AtKEYFLAGS		; temp has keyflags - current digit
	ld	temp_1,Z		; temp_1 has current BCD digits
	lds	temp_2,AtKEYPRESS	; temp_2 has keypress
;
	sbrs	temp,0			; If even digit (0-7)
	rjmp	S1HIGH_NIBBLE		; then put keypress in high nibble
	andi	temp_1,$F0		; Otherwise store keypress
	andi	temp_2,$0F		; Mask off original digit
	rjmp	S1REFJUMP2
S1HIGH_NIBBLE:
	swap	temp_2			; then put keypress in high nibble
	andi	temp_1,$0F
	andi	temp_2,$F0		; Mask off original digit
S1REFJUMP2:
	add	temp_1,temp_2		; Store back BCD data
	st	Z,temp_1
;
	lds	temp,AtKEYFLAGS		; next digit
	inc	temp			; 
	sbrc	temp,3			; ?last digit
	andi	temp,$F0		; If so then reset to 0
	cbr	temp,$10		; Clear keypress flag
	sts	AtKEYFLAGS,temp		; and store back
;

        rjmp   	S1REFJUMP1       	; repeat
;
S1REFEND:
;
	rcall	BCD2BIN32		; Calculate binary data
	lds	temp,AtBinary		; Save start data
	sts	Sweep_data,temp
	lds	temp,AtBinary+1		; Save start data
	sts	Sweep_data+1,temp
	lds	temp,AtBinary+2		; Save start data
	sts	Sweep_data+2,temp
	lds	temp,AtBinary+3		; Save start data
	sts	Sweep_data+3,temp


        ldi     temp,$01                ; Clear display
        rcall   COMMAND_DISPLAY
        rcall   WAIT_2msec
	ldi	temp,$0F		; Cursor on, flashing on
	rcall	COMMAND_DISPLAY
	rcall	WAIT_2msec
	ldi     temp,$C0        	; Cursor to 40
	rcall    COMMAND_DISPLAY	; Write to second line
        ldi     temp,$20                ; Blank
        rcall   DATA_DISPLAY
        ldi     temp,$53                ; S
        rcall   DATA_DISPLAY
        ldi     temp,$57                ; W
        rcall   DATA_DISPLAY
        ldi     temp,$45                ; E
        rcall   DATA_DISPLAY
        ldi     temp,$45                ; E
        rcall   DATA_DISPLAY
        ldi     temp,$50                ; P
        rcall   DATA_DISPLAY
        ldi     temp,$20                ; Blank
        rcall   DATA_DISPLAY
        ldi     temp,$53                ; S
        rcall   DATA_DISPLAY
        ldi     temp,$54                ; T
        rcall   DATA_DISPLAY
        ldi     temp,$4F                ; O
        rcall   DATA_DISPLAY
        ldi     temp,$50                ; P
        rcall   DATA_DISPLAY
;*******************************
; Write the current entered data
; and get the required BCD data
;********************************

;
	clr	temp	
	sts	AtKEYFLAGS,temp		; Clear keypress flag
S2REFJUMP1:
	rcall	DISPLAY_FREQ		; Display current digits
;
	ldi	temp,$81		; Set cursor
	lds	temp_1,AtKEYFLAGS		
	andi	temp_1,$07		; Mask off all bit but digit count
	cpi	temp_1,2		; If more than 2 digits then skip *
	brlo	S2SKIP_STAR
	inc	temp_1
S2SKIP_STAR:
	add	temp,temp_1		; Adjust to current digit
	rcall	COMMAND_DISPLAY
;
S2WAIT_FOR_KEY:
	lds 	temp,AtKEYFLAGS		; wait for keypreess
        sbrs    temp,4          	; 
        rjmp    S2WAIT_FOR_KEY        	; 
;
	lds	temp,AtKEYPRESS		; Get current keypress
	cpi	temp,$23		; ? is keypress #
	breq	S2REFEND			; if so then end	
;
;******************************
; Calculate address of BCD data
;*****************************					
	ldi	temp_1,AtBCD		; address of BCD data
	lds	temp,AtKEYFLAGS		; Get current digit
	andi	temp,$07		; Mask off all but current digit
	mov	temp_2,temp		; make copy 
	asr	temp_2			; divide by 2
	add	temp_1,temp_2		; add to pointer to AtBCD
	mov	r30,temp_1		; Use Z as pointer
	clr	r31
;
	lds	temp,AtKEYFLAGS		; temp has keyflags - current digit
	ld	temp_1,Z		; temp_1 has current BCD digits
	lds	temp_2,AtKEYPRESS	; temp_2 has keypress
;
	sbrs	temp,0			; If even digit (0-7)
	rjmp	S2HIGH_NIBBLE		; then put keypress in high nibble
	andi	temp_1,$F0		; Otherwise store keypress
	andi	temp_2,$0F		; Mask off original digit
	rjmp	S2REFJUMP2
S2HIGH_NIBBLE:
	swap	temp_2			; then put keypress in high nibble
	andi	temp_1,$0F
	andi	temp_2,$F0		; Mask off original digit
S2REFJUMP2:
	add	temp_1,temp_2		; Store back BCD data
	st	Z,temp_1
;
	lds	temp,AtKEYFLAGS		; next digit
	inc	temp			; 
	sbrc	temp,3			; ?last digit
	andi	temp,$F0		; If so then reset to 0
	cbr	temp,$10		; Clear keypress flag
	sts	AtKEYFLAGS,temp		; and store back
;

        rjmp   	S2REFJUMP1       		; repeat
;
S2REFEND:
;	
	rcall	BCD2BIN32		; Calculate second freq
	lds	temp,AtBinary		; 
	sts	Sweep_data+4,temp
	lds	temp,AtBinary+1		; Save stop data
	sts	Sweep_data+5,temp
	lds	temp,AtBinary+2		; 
	sts	Sweep_data+6,temp
	lds	temp,AtBinary+3		;
	sts	Sweep_data+7,temp

        ldi     temp,$01                ; Clear display
        rcall   COMMAND_DISPLAY
        rcall   WAIT_2msec
	ldi	temp,$0F		; Cursor on, flashing on
	rcall	COMMAND_DISPLAY
	rcall	WAIT_2msec
	ldi     temp,$C0        	; Cursor to 40
	rcall    COMMAND_DISPLAY	; Write to second line
        ldi     temp,$20                ; Blank
        rcall   DATA_DISPLAY
        ldi     temp,$53                ; S
        rcall   DATA_DISPLAY
        ldi     temp,$57                ; W
        rcall   DATA_DISPLAY
        ldi     temp,$45                ; E
        rcall   DATA_DISPLAY
        ldi     temp,$45                ; E
        rcall   DATA_DISPLAY
        ldi     temp,$50                ; P
        rcall   DATA_DISPLAY
        ldi     temp,$20                ; Blank
        rcall   DATA_DISPLAY
        ldi     temp,$53                ; S
        rcall   DATA_DISPLAY
        ldi     temp,$54                ; T
        rcall   DATA_DISPLAY
        ldi     temp,$45                ; E
        rcall   DATA_DISPLAY
        ldi     temp,$50                ; P
        rcall   DATA_DISPLAY
;*******************************
; Write the current entered data
; and get the required BCD data
;********************************

;
	clr	temp	
	sts	AtKEYFLAGS,temp		; Clear keypress flag
S3REFJUMP1:
	rcall	DISPLAY_FREQ		; Display current digits
;
	ldi	temp,$81		; Set cursor
	lds	temp_1,AtKEYFLAGS		
	andi	temp_1,$07		; Mask off all bit but digit count
	cpi	temp_1,2		; If more than 2 digits then skip *
	brlo	S3SKIP_STAR
	inc	temp_1
S3SKIP_STAR:
	add	temp,temp_1		; Adjust to current digit
	rcall	COMMAND_DISPLAY
;
S3WAIT_FOR_KEY:
	lds 	temp,AtKEYFLAGS		; wait for keypreess
        sbrs    temp,4          	; 
        rjmp    S3WAIT_FOR_KEY        	; 
;
	lds	temp,AtKEYPRESS		; Get current keypress
	cpi	temp,$23		; ? is keypress #
	breq	S3REFEND		; if so then end	
;
;******************************
; Calculate address of BCD data
;*****************************					
	ldi	temp_1,AtBCD		; address of BCD data
	lds	temp,AtKEYFLAGS		; Get current digit
	andi	temp,$07		; Mask off all but current digit
	mov	temp_2,temp		; make copy 
	asr	temp_2			; divide by 2
	add	temp_1,temp_2		; add to pointer to AtBCD
	mov	r30,temp_1		; Use Z as pointer
	clr	r31
;
	lds	temp,AtKEYFLAGS		; temp has keyflags - current digit
	ld	temp_1,Z		; temp_1 has current BCD digits
	lds	temp_2,AtKEYPRESS	; temp_2 has keypress
;
	sbrs	temp,0			; If even digit (0-7)
	rjmp	S3HIGH_NIBBLE		; then put keypress in high nibble
	andi	temp_1,$F0		; Otherwise store keypress
	andi	temp_2,$0F		; Mask off original digit
	rjmp	S3REFJUMP2
S3HIGH_NIBBLE:
	swap	temp_2			; then put keypress in high nibble
	andi	temp_1,$0F
	andi	temp_2,$F0		; Mask off original digit
S3REFJUMP2:
	add	temp_1,temp_2		; Store back BCD data
	st	Z,temp_1
;
	lds	temp,AtKEYFLAGS		; next digit
	inc	temp			; 
	sbrc	temp,3			; ?last digit
	andi	temp,$F0		; If so then reset to 0
	cbr	temp,$10		; Clear keypress flag
	sts	AtKEYFLAGS,temp		; and store back
;

        rjmp   	S3REFJUMP1     		; repeat
;
S3REFEND:
	cli				; clear interrupts
	clr	temp	
	sts	AtKEYFLAGS,temp		; Clear keypress flag
	sts	AtKEYPRESS,temp		; Clear keypress
;
	rcall	BCD2BIN32		; Calculate delta freq
	lds	temp,AtBinary		; 
	sts	Sweep_data+8,temp
	lds	temp,AtBinary+1		; Save step data
	sts	Sweep_data+9,temp
	lds	temp,AtBinary+2		; 
	sts	Sweep_data+10,temp
	lds	temp,AtBinary+3		;
	sts	Sweep_data+11,temp
;
	lds	temp,Sweep_data		; Get all the sweep data
	lds	temp_1,Sweep_data+1	; to calculate the current freq
	lds	temp_2,Sweep_data+2
	lds	temp_3,Sweep_data+3	; Start 
	sts	Sweep_data+12,temp	; Save a copy of the 
	sts	Sweep_data+13,temp_1	; current freq	
	sts	Sweep_data+14,temp_2
	sts	Sweep_data+15,temp_3
	sts	AtBinary,temp		; freq to DDS
	sts	AtBinary+1,temp_1
	sts	AtBinary+2,temp_2
	sts	AtBinary+3,temp_3
	rcall	CALC_1HZ		; Convert to 48 bits 1 Hz steps
	ldi	temp,$02		; DDS Freq 1 address 
	sts	DDS_serial_address,temp
	rcall	UD_DDS			; and write start freq to DDS
;
SWEEP_LOOP:				; 
	lds	temp,Sweep_data+12	; Get current sweep data
	lds	temp_1,Sweep_data+13	; 
	lds	temp_2,Sweep_data+14
	lds	temp_3,Sweep_data+15
	sts	AtBinary,temp		; freq to DDS
	sts	AtBinary+1,temp_1
	sts	AtBinary+2,temp_2
	sts	AtBinary+3,temp_3
	rcall	CALC_1HZ		; Convert to 48 bits 1 Hz steps
	ldi	temp,$02		; DDS Freq 1 address 
	sts	DDS_serial_address,temp
	rcall	UD_DDS			; and write freq to DDS
;
	sei				; enable interrupts to check
	lds	temp,AtKEYPRESS		; Get current keypress
	cpi	temp,$23		; ? is keypress #
	breq	S4REFEND		; if so then end	
	cli				; clear interrupts again
	; 
	lds	temp,Sweep_data+12	; Get cuurent sweep data
	lds	temp_1,Sweep_data+13	; to calculate the next freq
	lds	temp_2,Sweep_data+14
	lds	temp_3,Sweep_data+15	; 
;
	lds	temp_8,Sweep_data+8	; Step data
	lds	temp_9,Sweep_data+9	; Step 
	lds	temp_10,Sweep_data+10	; Step
	lds	temp_11,Sweep_data+11	; Step
;
	clc				; Clear carry
	add	temp_3,temp_11		; add step to current freq
	adc	temp_2,temp_10		; with carry
	adc	temp_1,temp_9		; with carry
	adc	temp,temp_8		; with carry
;
	sts	Sweep_data+12,temp	; Save a copy of the 
	sts	Sweep_data+13,temp_1	; current freq	
	sts	Sweep_data+14,temp_2
	sts	Sweep_data+15,temp_3
;
	lds	temp_4,Sweep_data+4	; Stop data
	lds	temp_5,Sweep_data+5	; Stop
	lds	temp_6,Sweep_data+6	; Stop
	lds	temp_7,Sweep_data+7	; Stop
;
	clc
	sub	temp_3,temp_7		; Compare with max freq
	sbc	temp_2,temp_6
	sbc	temp_1,temp_5
	sbc	temp,temp_4
	brcc	RESET_SWEEP		; If stop freq reached then
	rjmp	SWEEP_LOOP		; start again
;
RESET_SWEEP:
	lds	temp,Sweep_data		; Get start data
	lds	temp_1,Sweep_data+1	; to reset he current freq
	lds	temp_2,Sweep_data+2
	lds	temp_3,Sweep_data+3	; Start 
	sts	Sweep_data+12,temp	; Save to current freq	
	sts	Sweep_data+13,temp_1	; 
	sts	Sweep_data+14,temp_2
	sts	Sweep_data+15,temp_3
	rjmp	SWEEP_LOOP
;
S4REFEND:       	
	clr	temp			; clear keypress flag
	sts	AtKEYFLAGS,temp
	ret
